# Run any binary easily on AWS Lambda

Although most of the examples are based on [AWS Lambda](https://aws.amazon.com/lambda/) this module can be used in normal Node.js applications.

The idea of this solution for AWS Lambda is explained at my article https://www.lambrospetrou.com/articles/aws-lambda-meets-racket/

This module allows you to start any executable as a subprocess (using ```child_process.spawn()```) and communicate with it over ```standard input and output```. It is really just a wrapper on **child_process** and **readline** to reduce the boilerplate needed in Lambdas.

I tested this module with [Racket](https://racket-lang.org/), [Go](https://golang.org/), [cat](https://ss64.com/bash/cat.html), and you can use it for **any** binary that runs on your system or in case of AWS Lambda any binary that runs on Amazon Linux.

## Examples

You can find examples of AWS Lambda functions in the ```_examples``` directory.

To test and create the zip file that you need to upload just run ```make bundle``` from inside the example directory you want.

Make sure your AWS Lambda is configured to use **Node.js 6.10** and the handler name is set to ```wrapper.handler```.

Upload the ```bundle.zip``` generated by the ```make``` command above and **Test** it a few times to notice the **sub-millisecond** execution times!

## Communication protocol helpers

This package provides communication helpers for line-by-line protocols, and raw bytes protocols.

You can contribute to the package by adding new communication helpers and making a Pull Request. However with the **line-by-line** and **byte-by-byte** protocols I think you can pretty much do anything.